using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using CanAerospaceCore;
using FTD2XX_NET;
using System.Threading;

namespace WindowsFormsApplication2.LRT3
{
    public partial class LRT3Form : Form
    {
        public LRT3Form()
        {
            InitializeComponent();
        }

        private void LRT3Form_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.LRT3_FormLocation = Location;
            Properties.Settings.Default.Save();
        }

        private void LRT3Form_Load(object sender, EventArgs e)
        {
            StartPosition = FormStartPosition.Manual;
            Location = Properties.Settings.Default.LRT3_FormLocation;
        }
        
        private void LRT3_refresh_Click(object sender, EventArgs e)
        {
            Form1 mainform = Application.OpenForms.OfType<Form1>().First();
            mainform.ActiveForm2 = null;
            this.Close();
        }

        private void LRT3_button_click(object sender, EventArgs e)
        {
            if (Application.OpenForms.OfType<Form1>().Any())
            {
                Form1 mainform = Application.OpenForms.OfType<Form1>().First();
                if (mainform.ActiveForm2 != null)
                {
                    Button button = sender as Button;
                    uint weaponChannel = 100;
                    byte weaponNodeId = 141;
                    CanData dataToWrite = new CanData();
                    //Thread.Sleep(1000);
                    byte register = 10;
                    switch (button.Name)
                    {
                        case ("LRT3_shot"):
                            dataToWrite.SetAsUchar((byte)(16));
                            break;
                        default:
                            return;
                        //break;
                    }
                    RegisterKey regKey = new RegisterKey(weaponNodeId, register);
                    mainform.canConnection.SendRegisterWriteRequest(weaponChannel, regKey, dataToWrite);
                }

            }

        }

        public void LRT3_numericUpDown_ValueChanged(object sender, EventArgs e)
        {
            NumericUpDown editbox = sender as NumericUpDown;
            uint weaponChannel = 100;
            byte weaponNodeId = 141;
            CanData dataToWrite = new CanData();
            //Thread.Sleep(1000);

            byte register = 0;
            switch (editbox.Name)
            {
                case ("LRT3_treshlow"):
                    register = 29;
                    dataToWrite.SetAsUchar((byte)(editbox.Value));
                    break;
                case ("LRT3_treshhigh"):
                    register = 30;
                    dataToWrite.SetAsUchar((byte)(editbox.Value));
                    break;
                case ("LRT3_triggerrelease"):
                    register = 31;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("LRT3_triggerhold"):
                    register = 32;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("LRT3_triggerdaoffset"):
                    register = 33;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("LRT3_boltlocktresh"):
                    register = 100;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("LRT3_boltunlocktresh"):
                    register = 101;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("LRT3_firingpintresh"):
                    register = 102;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("LRT3_firingpindaoffset"):
                    register = 103;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("LRT3_safetresh"):
                    register = 104;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("LRT3_safedaoffset"):
                    register = 105;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                default:
                    return;
                //break;
            }
            if (register == 0) return;
            if (Application.OpenForms.OfType<Form1>().Any())
            {
                Form1 mainform = Application.OpenForms.OfType<Form1>().First();
                if (mainform.ActiveForm2 != null)
                {
                    RegisterKey regKey = new RegisterKey(weaponNodeId, register);
                    if (mainform.canConnection.SendRegisterWriteRequest(weaponChannel, regKey, dataToWrite)) MessageBox.Show("Value changed");
                }

            }

        }


    }
}
